<template>
<el-container>
	<el-aside width="200px" v-loading="showGrouploading">
		<el-container>
			<el-header>
				<el-input placeholder="输入关键字进行过滤" v-model="groupFilterText" clearable></el-input>
			</el-header>
			<el-main class="nopadding">
				<el-tree ref="group" class="menu" node-key="id" :data="group" :props="{label: 'title'}" :current-node-key="''" :highlight-current="true" :expand-on-click-node="false" :filter-node-method="groupFilterNode" @node-click="groupClick"></el-tree>
			</el-main>
		</el-container>
	</el-aside>
	<el-container>
			<el-header>
				<div class="left-panel">
					<el-button type="primary" icon="el-icon-plus" @click="add"></el-button>
					<el-button type="danger" plain icon="el-icon-delete" :disabled="selection.length==0" @click="batch_del"></el-button>
					<el-button type="primary" plain :disabled="selection.length!=1" @click="roleSet">分配角色</el-button>
					<el-button type="primary" plain @click="insertData" v-if="false">数据导入</el-button>
				</div>
				<div class="right-panel">
					<div class="right-panel-search">
						<el-input v-model="search.name" placeholder="登录账号 / 姓名" clearable></el-input>
						<el-button type="primary" icon="el-icon-search" @click="upsearch"></el-button>
					</div>
				</div>
			</el-header>
			<el-main class="nopadding">
				<scTable ref="table" :apiObj="apiObj" @selection-change="selectionChange" stripe remoteSort remoteFilter>
					<el-table-column type="selection" width="50"></el-table-column>
					<el-table-column label="头像" width="80" column-key="avatar" :filters="[{text: '已上传', value: '1'}, {text: '未上传', value: '0'}]">
						<template #default="scope">
							<el-avatar :src="scope.row.avatar" shape="square" size="small"></el-avatar>
						</template>
					</el-table-column>
					<el-table-column label="UID" prop="uid" width="150" sortable='custom'></el-table-column>
					<el-table-column label="登录账号" prop="username" width="150" sortable='custom' column-key="username" :filters="[{text: '系统账号', value: '1'}, {text: '普通账号', value: '0'}]"></el-table-column>
					<el-table-column label="姓名" prop="nickname" width="150" sortable='custom'></el-table-column>
					<el-table-column label="所属角色" prop="roleName" width="200">
						<template #default="scope">
							<el-tag v-for="item in scope.row?.roles" :key="item.id">{{item.title}}</el-tag>
						</template>
					</el-table-column>
					<el-table-column label="所属部门" prop="department_name" width="200">
						<template #default="scope">
							{{scope.row.department?.title}}
						</template>
					</el-table-column>
					<el-table-column label="加入时间" prop="created_at" width="150" sortable='custom'></el-table-column>
					<el-table-column label="操作" fixed="right" align="right" width="180">
						<template #default="scope">
							<el-button-group>
								<el-button type="success" size="small" @click="table_show(scope.row, scope.$index)">查看</el-button>
								<el-button type="primary" size="small" @click="table_edit(scope.row, scope.$index)">编辑</el-button>
								<el-popconfirm title="确定删除吗？" @confirm="table_del(scope.row, scope.$index)">
									<template #reference>
										<el-button type="danger" size="small">删除</el-button>
									</template>
								</el-popconfirm>
							</el-button-group>
						</template>
					</el-table-column>
				</scTable>
			</el-main>
	</el-container>
</el-container>

<save-dialog v-if="dialog.save" ref="saveDialog" @success="handleSuccess" @closed="dialog.save=false"></save-dialog>
<role-dialog v-if="dialog.role" ref="roleDialog" @success="handleSuccess" @closed="dialog.role=false"></role-dialog>

</template>

<script>
import saveDialog from './save'
import roleDialog from './role'

export default {
	name: 'auth.user',
	components: {
		saveDialog,
		roleDialog
	},
	data() {
		return {
			dialog: {
				save: false
			},
			showGrouploading: false,
			groupFilterText: '',
			group: [],
			apiObj: this.$API.auth.users.list,
			selection: [],
			search: {name: '', page: 1}
		}
	},
	watch: {
		groupFilterText(val) {
			this.$refs.group.filter(val);
		}
	},
	mounted() {
		this.getGroup()
	},
	methods: {
		//添加
		add(){
			this.dialog.save = true
			this.$nextTick(() => {
				this.$refs.saveDialog.open()
			})
		},
		//编辑
		table_edit(row){
			this.dialog.save = true
			this.$nextTick(() => {
				this.$refs.saveDialog.open('edit').setData(row)
			})
		},
		//查看
		table_show(row){
			this.dialog.save = true
			this.$nextTick(() => {
				this.$refs.saveDialog.open('show').setData(row)
			})
		},
		//删除
		async table_del(row, index){
			var reqData = {id: row.uid}
			var res = await this.$API.auth.users.delete.post(reqData);
			if(res.code == 1){
				this.$refs.table.refresh()
				this.$message.success("删除成功")
			}else{
				this.$message.error(res.message)
			}
		},
		//批量删除
		async batch_del(){
			this.$confirm(`确定删除选中的 ${this.selection.length} 项吗？`, '提示', {
				type: 'warning'
			}).then(async () => {
				var ids = this.selection.map(item => item.uid)
				var reqData = {ids: ids}
				var res = await this.$API.auth.users.delete.post(reqData);
				if(res.code == 1){
					this.$refs.table.refresh()
					this.$message.success("删除成功")
				}else{
					this.$message.error(res.message)
				}
			}).catch(() => {

			})
		},
		//权限设置
		roleSet(){
			if(this.selection.length != 1){
				this.$message.error("请选择一条数据")
				return false;
			}
			this.dialog.role = true
			this.$nextTick(() => {
				this.$refs.roleDialog.open().setData(this.selection[0])
			})
		},
		insertData(){
			this.dialog.insert = true
			this.$nextTick(() => {
				this.$refs.insertDialog.open()
			})
		},
		//表格选择后回调事件
		selectionChange(selection){
			this.selection = selection;
		},
		//加载树数据
		async getGroup(){
			this.showGrouploading = true;
			var res = await this.$API.auth.department.list.get({is_tree: 1});
			this.showGrouploading = false;
			var allNode ={id: '', title: '所有'}
			res.data.unshift(allNode);
			this.group = res.data;
		},
		//树过滤
		groupFilterNode(value, data){
			if (!value) return true;
			return data.label.indexOf(value) !== -1;
		},
		//树点击事件
		groupClick(data){
			var params = {
				department_id: data.id
			}
			this.$refs.table.reload(params)
		},
		//搜索
		upsearch(){
			this.$refs.table.upData(this.search)
		},
		//本地更新数据
		handleSuccess(){
			this.$refs.table.refresh()
		}
	}
}
</script>

<style>
</style>
